var FTG = function ($) {
    var _loading = null;

    return {
        show_loading: function () {
            _loading = $("<div><p class='loading'></div>").dialog({
                modal: true,
                dialogClass: "noTitle"
            });
        },
        hide_loading: function () {
            if(_loading) {
                _loading.dialog("destroy");
                _loading = null;
            }
        },
        delete_image: function (id) {
            FTG.show_loading();
            $.post(ajaxurl, {
                action: 'delete_image',                
                FinalTiles_gallery: $('#FinalTiles_gallery').val(),
                id: id
            }, function () {
                FTG.load_images();
            });
        },
        load_images: function () {
            if(!_loading)
                FTG.show_loading();

            var source = $("[name=ftg_source]").val();

            $.post(ajaxurl, {
                action: source == 'posts' ? 'refresh_posts' : 'list_images',
                FinalTiles_gallery: $('#FinalTiles_gallery').val(),
                gid: $("#gallery-id").val()
            }, function (html) {
                $("#image-list").empty().append(html);
                if(source == 'images') {
                    $("#image-list").sortable({
                        update: function () {
                            FTG.show_loading();
                            var ids = [];
                            $("#image-list .item").each(function () {
                                ids.push($(this).data("id"));
                            });
                            var data = {
                                action: 'sort_images',
                                FinalTiles_gallery: $('#FinalTiles_gallery').val(),
                                ids: ids.join(',')
                            };
                            $.post(ajaxurl, data, function () {
                                FTG.hide_loading();
                            });
                        }
                    });
                };

                $("#image-list .remove").click(function (e) {
                    e.preventDefault();
                    e.stopPropagation();

                    var $item = $(this).parents(".item:first");
                    var id = $item.data("id");

                    var data = {
                        action: 'delete_image',
                        FinalTiles_gallery: $('#FinalTiles_gallery').val(),
                        id: id
                    };

                    FTG.show_loading();
                    $.post(ajaxurl, data, function () {
                        $item.remove();
                        FTG.hide_loading();                        
                    });
                });

                $("#image-list .checkbox").click(function () {
                    $(this).toggleClass("checked");
                    $(this).parents(".item:first").toggleClass("selected");
                });
                
                FTG.hide_loading();
            });
        },
        edit_image: function(form) {
            var data = {};
            form.find("input[type=text], input:checked, textarea, input[type=hidden], select").each(function() {
                data[$(this).attr("name")] = $(this).val();
            });
            data.action = 'save_image';
            data.type = 'edit';
            data.source = $("[name=ftg_source]").val();
            data.FinalTiles_gallery = $('#FinalTiles_gallery').val();

            FTG.show_loading();
            $.ajax({
                url: ajaxurl,
                data: data,
                dataType: "json",
                type: "post",
                error: function(a,b,c) {
                    FTG.hide_loading();
                },
                success: function(r) {                        
                    if(r.success) {
                        FTG.load_images();
                    } else {
                        FTG.hide_loading();
                    }
                }
            });
        },		
        update_filters: function() {
            var ff = [];
            $(".gallery-filters .f").each(function () {
                var val = $.trim($(this).val());
                if(val.length > 0 && $.inArray(val, ff) < 0) {
                    ff.push(val);
                }
            });
            $(".gallery-filters [name=ftg_filters]").val(ff.join('|'));
        },
        update_custom_isf: function() {
	    	var isf = [];
	    	$(".custom_isf tbody tr").each(function (i, o) {
		    	var res = $.trim($(o).find("input.res").val());
		    	var size = $.trim($(o).find("input.size").val());
		    	
		    	if(res && size) {
			    	isf.push(res + "," + size);
		    	}
	    	});
	    	$("[name=ftg_imageSizeFactorCustom]").val(isf.join("|"));
        },
        add_filter: function (value) {            
            var row = $("<p style='display:none'><a href='#' class='button alert del'>x</a> <input class='f' type='text' /></p>");
            if(value)
                row.find(".f").val(value);

            $(".filters .text").append(row);
            row.slideDown();
            row.find(".del").click(function (e) {
                e.preventDefault();
                row.slideUp(function () {
                    $(this).remove();
                });
                FTG.update_filters();
            });
        },
        add_isf: function(value) {
	        var $item = $("<tr><td></td><td></td><td></td></tr>");
	        $("td", $item).eq(0).append("<a class='button alert del' href='#'>X</a>");
			$("td", $item).eq(1).append("<input type='text' class='res' />");
			$("td", $item).eq(2).append("<input type='text' class='size' />");
			
	        $item.find("a").click(function (e) {
		        e.preventDefault();		        
		        $item.remove();
	        });
	        if(value) {
		        var data = value.split(',');
		        $item.find(".res").val(data[0]);
		        $item.find(".size").val(data[1]);		        
		    }
		    $(".custom_isf tbody").append($item);
        },
        init_gallery: function () {
            var ff = $(".filters [name=ftg_filters]").val().split('|');
            
            if(ff.length == 0 || ff[0] == "") {
                FTG.add_filter();
            } else {
                for(var i=0; i < ff.length; i++) {
                    if(ff[i].length > 0)
                        FTG.add_filter(ff[i]);
                }
            }
			
			var isf = $("[name=ftg_imageSizeFactorCustom]").val().split('|');
			
			for(var i=0; i < isf.length; i++) {
				if(isf[i].length)
	                FTG.add_isf(isf[i]);
            }
        },
        refresh_posts: function () {
            FTG.show_loading();
            var data = {
                action: 'refresh_posts',
                FinalTiles_gallery: $('#FinalTiles_gallery').val()
            };
            data.post_categories = $("[name=post_categories]:checked").map(function() {
	            return this.value;
            }).get().join();
            
            data.post_types = $("[name=post_types]:checked").map(function() {
	            return this.value;
            }).get().join();
            
            data.post_tags = $("[name=post_tags]:checked").map(function() {
	            return this.value;
            }).get().join();
            
            $.ajax({
                url: ajaxurl,
                data: data,
                type: "post",
                error: function (a, b, c) {
                    console.log(a, b, c);
                    FTG.hide_loading();
                },
                success: function (html) {
                    $("#image-list").empty().append(html)
                    FTG.hide_loading();
                }
            });
        },
        save_gallery: function() {
	        // !gallery save
            var data = {};
            data.action = 'save_gallery';
            FTG.update_filters();
            FTG.update_custom_isf();
            
            $(".form-fields").find("input[type=text], select, input:checked, input[type=hidden], textarea").each(function () {
	            var name = $(this).attr("name");
	            if(name && name.substr(0, 4) == "ftg_") {
	            	var value = $(this).val();
	    	
	            	if($.isArray(value))
	            		value = value[0];
	                data[name] = value;
	            }
            });           
            
            data.FinalTiles_gallery = $("[name=FinalTiles_gallery]").val();
            data.ftg_gallery_edit = $("[name=ftg_gallery_edit]").val();

            if(parseInt(data.gridCellSize) < 2)
                data.gridCellSize = 2;
            
            if(data.galleryName == "") {
                var p = $("<div title='Attention'>Insert a name for the gallery</div>").dialog({
                    modal: true,
                    buttons: {
                        Close: function () {
                            p.dialog("destroy");
                        }
                    }
                });
                return false;
            }

            FTG.show_loading();

            $.ajax({
                url: ajaxurl,
                data: data,
                dataType: "json",
                type: "post",
                error: function(a,b,c) {
                    FTG.hide_loading();
                },
                success: function(r) {
                    if(data.ftg_gallery_edit)
                        FTG.hide_loading();
                    else
                        location.href = "?page=edit-gallery";                     
                }
            });
        },
		bind: function () {			
			$("#add-submit").click(function (e) {
                e.preventDefault();
                FTG.add_image();
            });
            $("#add-gallery, #edit-gallery").click(function (e) {
                e.preventDefault();
                FTG.save_gallery();
            });
            $(".filters a").click(function (e) {
                e.preventDefault();
                FTG.add_filter();
            });
            $(".custom_isf a").click(function (e) {
	            e.preventDefault();
	            FTG.add_isf();
            });
            $("#image-list").on("click", ".item .thumb", function () {
	            $(this).parents(".item").toggleClass("selected");
	            $(this).parents(".item").find(".checkbox").toggleClass("checked");
            });
            $("#image-list").on("click", ".edit", function (e) {
            	e.preventDefault();
            	var source = $("[name=ftg_source]").val();

                var $item = $(this).parents(".item");
                if($item.data("type") == "video") {	
	                // !video edit
	                var embed = $("pre.imagepath", $item).html();
	                embed = String(embed).replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"');
	                	               	                
	                var $panel = $("#video-panel-model").clone().attr("id", "video-panel");
	                $("textarea", $panel).val(embed);
	                $("input[type=hidden]", $item).each(function () {
                        if($(this).attr("name"))
                            $(this).clone().appendTo($panel);
                    });
	                $(".save", $panel).text("Update");
	                
		            $panel.css({
	                    marginTop: $(window).scrollTop() - (246 / 2),
	                    marginLeft: -(600 / 2)
	                }).appendTo("body").fadeIn();
	                $(".overlay").fadeIn();
	               	return;
                }
                
                var panel = $("#image-panel-model").clone().attr("id", "image-panel");
                panel.css({
                    marginTop: $(window).scrollTop() - (246 / 2),
                    marginLeft: -(600 / 2)
                });

                $("[name=target]", panel).val($("[name=target]", $item).val());
	            $("[name=link]", panel).val($("[name=link]", $item).val());
                $(".figure", panel).append($("img", $item).clone());
                $(".sizes", panel).append($("select", $item).clone());
                $("textarea", panel).val($("pre.description", $item).html());
                $(".copy", $item).clone().appendTo(panel);

                if (source == 'posts') {
                    panel.find("[name=link], textarea").hide();
                }

                var selFilters = $item.find("[name=filters]").val().split('|');
                var filters = $("[name=ftg_filters]").val().split('|');

                for(var i=0; i < filters.length; i++) {
                    if($.trim(filters[i]).length > 0) {
                        var ft = $("<div class='checkbox'>" + $.trim(filters[i]) + "</div>");
                        if($.inArray(filters[i], selFilters) > -1)
                            ft.addClass("checked");

                        $(".filters", panel).append(ft);
                    }
                }
                
                $(".filters .checkbox", panel).click(function() {
                    $(this).toggleClass("checked");
                });
                
                //$("body").append("<div class='overlay' style='display:none' />");
                $(".overlay").fadeIn();
                panel.appendTo("body").fadeIn();

                var link = $item.find("[name=link]").val();
                
                $(".buttons a", panel).click(function (e) {
                    e.preventDefault();
                    
                    switch($(this).data("action")) {
                        case "save":
                            var data = {
                                source: source,
                                action : 'save_image',
                                FinalTiles_gallery : $('#FinalTiles_gallery').val()
                            };
                            $("input[type=text], input[type=hidden], input[type=radio]:checked, input[type=checkbox]:checked, textarea, select", panel).each(function () {
                                if($(this).attr("name"))
                                    data[$(this).attr("name")] = $(this).val();
                            });

                            var savFilters = [];
                            $(".filters .checked", panel).each(function(i, o) {
                                savFilters.push($(o).text());
                            });
                            data.filters = savFilters.join("|");

                            $("#image-panel .close").trigger("click");
                            FTG.show_loading();
                            $.ajax({
                                url: ajaxurl,
                                data: data,
                                dataType: "json",
                                type: "post",
                                error: function(a,b,c) {
                                	console.log(a,b,c);
                                    FTG.hide_loading();
                                },
                                success: function(r) {                               
                                    FTG.hide_loading();
                                    FTG.load_images();
                                }
                            });                            
                            break;
                        case "cancel":
                            $("#image-panel .close").trigger("click");
                            break;
                    }
                });

                $("#image-panel .close, .overlay").click(function (e) {
                    e.preventDefault();
                    panel.fadeOut(function () {
                        $(this).remove();
                    });
                    $(".overlay").fadeOut(function () {
                        //$(this).remove();
                    });
                });
            });            
            $("body").on("change", "[name=ftg_source]", function () {
                $("#images .source-panel").hide();
                $("#images .source-" + $(this).val()).show();

                var source = $(this).val();
                if (source == 'images') {
                    FTG.load_images();
                }
                if (source == 'posts') {
                    FTG.refresh_posts();
                }
            });
            
            var refreshPostsTO=0;
            $("body").on("click", "[name=post_types],[name=post_categories],[name=post_tags]", function () {                
                $("[name=ftg_post_categories]").val($("[name=post_categories]:checked").map(function() {
                    return this.value;
                }).get().join());
                
                $("[name=ftg_post_types]").val($("[name=post_types]:checked").map(function() {
                    return this.value;
                }).get().join());
                
                $("[name=ftg_post_tags]").val($("[name=post_tags]:checked").map(function() {
                    return this.value;
                }).get().join());
                
                FTG.refresh_posts();
            });
            $("body").on("click", "[name=click_action]", function () {
                if($(this).val() == "url") {
                    $(this).siblings("[name=url]").get(0).disabled = false;
                } else {
                    $(this).siblings("[name=url]").val("").get(0).disabled = true;
                }
            });

            $(".bulk a").click(function (e) {
                e.preventDefault();

                var $bulk = $(".bulk");

                switch($(this).data("action"))
                {
                    case "select":
                        $("#images .item").addClass("selected");
                        $("#images .item .checkbox").addClass("checked");
                        break;
                    case "deselect":
                        $("#images .item").removeClass("selected");
                        $("#images .item .checkbox").removeClass("checked");
                        break;
                    case "toggle":
                        $("#images .item").toggleClass("selected");
                        $("#images .item .checkbox").toggleClass("checked");
                        break;
                    case "filter":
                        var selected = [];
                        $("#images .item.selected").each(function (i, o) {
                            selected.push($(o).data("id"));
                        });
                        if(selected.length == 0) {
                            alert("No images selected");
                        } else {
                            $(".panel", $bulk).hide();
                            $(".panel strong", $bulk).text("Select filters");
                            $(".panel .text", $bulk).text("");
                            
                            var filters = $("[name=ftg_filters]").val().split('|');
                            for(var i=0; i < filters.length; i++) {
                                if($.trim(filters[i]).length > 0) {
                                    var ft = $("<div class='checkbox'>" + $.trim(filters[i]) + "</div>");
                                    $(".panel .text", $bulk).append(ft);
                                }
                            }
                            
                            $(".panel .checkbox", $bulk).click(function() {
                                $(this).toggleClass("checked");
                            });

                            $(".cancel", $bulk).unbind("click").click(function (e) {
                                e.preventDefault();
                                $(".panel", $bulk).slideUp();
                            });

                            $(".proceed", $bulk).unbind("click").click(function (e) {
                                e.preventDefault();

                                var filters = [];
                                $(".panel .checked", $bulk).each(function (i, o) {
                                    filters.push($(o).text());
                                });

                                $(".panel", $bulk).slideUp();

                                var data = {
                                    action: 'assign_filters',
                                    FinalTiles_gallery: $('#FinalTiles_gallery').val(),
                                    filters: filters.join("|"),
                                    id: selected.join(",")
                                };

                                FTG.show_loading();
                                $.post(ajaxurl, data, function () {
                                    FTG.hide_loading();                        
                                });
                            });

                            $(".panel", $bulk).slideDown();
                        }
                        break;
                    case "remove":
                        var selected = [];
                        $("#images .item.selected").each(function (i, o) {
                            selected.push($(o).data("id"));
                        });
                        if(selected.length == 0) {
                            alert("No images selected");
                        } else {
                            $(".panel", $bulk).hide();
                            $(".panel strong", $bulk).text("Confirm");
                            $(".panel .text", $bulk).text("You selected " + selected.length + " images to remove, proceed ?");

                            $(".cancel", $bulk).unbind("click").click(function (e) {
                                e.preventDefault();
                                $(".panel", $bulk).slideUp();
                            });

                            $(".proceed", $bulk).unbind("click").click(function (e) {
                                e.preventDefault();
                                $(".panel", $bulk).slideUp();

                                var data = {
                                    action: 'delete_image',
                                    FinalTiles_gallery: $('#FinalTiles_gallery').val(),
                                    id: selected.join(",")
                                };

                                FTG.show_loading();
                                $.post(ajaxurl, data, function () {
                                    $("#images .item.selected").remove();
                                    FTG.hide_loading();                        
                                });
                            });

                            $(".panel", $bulk).slideDown();
                        }
                        break;
                }
            });
            $("body").on("click", "#video-panel .close", function (e) {
                e.preventDefault();
                $("#video-panel textarea").val("");
                $("#video-panel, .overlay").fadeOut(function () {
                    $("#video-panel").remove();
                });
            });
            $("body").on("click", "#video-panel .buttons a", function (e) {
                e.preventDefault();

                switch($(this).data("action")) {
                    case "cancel":
                        $("#video-panel, .overlay").fadeOut(function () {
	                        $("#video-panel").remove();
                        });
                        break;
                    case "edit":
                    	// !video save
                    	var $panel = $("#video-panel"); 
                        var data = {
                            action : 'save_video',
                            embed : $("textarea", $panel).val(),
                            galleryId: $("#gallery-id").val(),
                            FinalTiles_gallery : $('#FinalTiles_gallery').val()
                        };
                                            
                        FTG.show_loading();
                        $("#video-panel, .overlay").fadeOut(function () {
	                    	$("#video-panel").remove();    
                        });
						
						$("input[type=hidden]", $panel).each(function () {
	                        if($(this).attr("name"))
	                            data[$(this).attr("name")] = $(this).val();
	                    });
						
                        $.ajax({
                            url: ajaxurl,
                            data: data,
                            dataType: "json",
                            type: "post",
                            error: function(a,b,c) {
                                FTG.hide_loading();
                                alert("error adding images");
                            },
                            success: function(r) {
                                if(r.success) {
                                    FTG.hide_loading();
                                    FTG.load_images();
                                }
                            }
                        });
                        break;
                }
            });
            $(".open-add-video").on("click", function (e) {
                e.preventDefault();
				var $panel = $("#video-panel-model").clone().attr("id", "video-panel");
                $panel.css({
                    marginTop: $(window).scrollTop() - (246 / 2),
                    marginLeft: -(600 / 2)
                }).appendTo("body").fadeIn();
                $(".overlay").fadeIn();
            });
            $(".open-media-panel").on("click", function(e) {
                e.preventDefault();
                tgm_media_frame = wp.media.frames.tgm_media_frame = wp.media({
                    multiple: true,
                    library: {
                        type: 'image'
                    },
                    title: 'Add image(s)',
                    button: {
                        text: 'Add image(s)'
                    },
                    states: [
                        new wp.media.controller.Library({
                            library:   wp.media.query({ type: 'image' }),
                            multiple:  true,
                            priority:  20,
                            filterable: 'all'
                        })
                    ]
                });

                tgm_media_frame.on('select', function() {
                    var selection = tgm_media_frame.state().get('selection');
                    var images = [];
                    
                    var errors = 0;
                    selection.map( function( attachment ) {
                        attachment = attachment.toJSON();
                        
                        if(! attachment.sizes) {
                        	errors++;
                        	return;
						}

                        var obj = {
                            description: attachment.caption,
                            imageId: attachment.id
                        };
						
						var currentImageSize = $(".current-image-size").val();
						
                        if(attachment.sizes[currentImageSize])
                            obj.imagePath = attachment.sizes[currentImageSize].url
                        else
                            obj.imagePath = attachment.url;

                        if(attachment.sizes.full)
                            obj.altImagePath = attachment.sizes.full.url;

                        images.push(obj);
                    });
					
					if(errors) {
						alert(errors + " images could not be added because the selected size is not available");
					}
					
                    var data = {
                        action : 'add_image',
                        enc_images : JSON.stringify(images),
                        galleryId: $("#gallery-id").val(),
                        FinalTiles_gallery : $('#FinalTiles_gallery').val()
                    };

                    FTG.show_loading();
                    $.ajax({
                        url: ajaxurl,
                        data: data,
                        dataType: "json",
                        type: "post",
                        error: function(a,b,c) {
                            FTG.hide_loading();
                            alert("error adding images");
                        },
                        success: function(r) {                        
                            if(r.success) {
                                FTG.hide_loading();
                                FTG.load_images();
                            }
                        }
                    });
                });

                tgm_media_frame.open();
            });
		}
	}
}(jQuery);
jQuery(function () {
	FTG.bind();
});